<div ng-controller="exportFormExcelController as self"
     ng-init="self.init(<?= $this->export ? $this->export->getId() : 'null' ?>,
              <?= $this->environment()->getClient()->getId() ?>,
              '<?= \Export\Entity\Export::TYPE_EXCEL ?>')">
    <ul class="breadcrumb">
        <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
        <li><?= $this->translate('administration_module_title') ?></li>
        <li><a href="<?= $this->url('export') ?>"><?= $this->translate('export_module_title') ?></a></li>
        <li class="active">
            <span ng-if="self.export.id">{{self.panelTitle}}</span>
            <span ng-if="!self.export.id"><?= $this->translate('exportExcel_nav_form') ?></span>
        </li>
    </ul>

    <h1 class="page-title">
        <?= $this->icon('word') ?> <?= $this->translate('export_module_title') ?>
    </h1>

    <div class="row row-padding">
        <div class="col-xs-12">
            <div class="panel">
                <div class="panel-heading">
                    <span ng-if="self.export.id">
                        {{self.panelTitle}}
                    </span>
                    <span ng-if="!self.export.id">
                        <?= $this->translate('exportExcel_nav_form') ?>
                    </span>

                    <div class="panel-heading-right">
                        <div class="panel-heading-actions" ng-if="self.export.id && self.export._rights.delete" tooltip="<?= $this->translate('tooltip_delete') ?>">
                            <?= $this->icon('delete', 'pointer', ['ng-click' => 'self.deleteExport()']) ?>
                        </div>
                    </div>
                </div>
                <div class="panel-body">
                    <form name="exportForm" ng-submit="self.saveExport()">
                        <input type="hidden" name="id"
                               ng-model="self.export.id"/>

                        <div class="row">
                            <div class="form-group required col-sm-4">
                                <label><?= $this->translate('export_field_name') ?></label>
                                <input type="text" name="name" class="form-control" required autocomplete="off"
                                       ng-model="self.export.name" ng-readonly="!self.export._rights.update"/>
                                <field-errors field="name" errors="self.errors.fields"></field-errors>
                            </div>
                        </div>

                        <div class="row">
                            <div class="form-group col-sm-4">
                                <label><?= $this->translate('export_field_year') ?></label>
                                <input type="text" pattern="[0-9]{4}" class="form-control" ng-model="self.export.year" ng-readonly="!self.export._rights.update"/>
                                <field-errors field="year" errors="self.errors.fields"></field-errors>
                            </div>
                        </div>

                        <div class="row">
                            <div class="form-group col-sm-4">
                                <input ng-model="self.export.groupByKeywords"
                                       ng-change="self.initGroupByKeywordsTitles()"
                                       ng-readonly="!self.export._rights.update"
                                       type="checkbox"
                                       id="groupByKeywords"/>

                                <label for="groupByKeywords">
                                    <?= $this->translate('export_field_groupByKeywords'); ?>
                                </label>

                                <field-errors field="groupByKeywords"
                                              errors="self.errors.fields">
                                </field-errors>
                            </div>
                        </div>

                        <div ng-if="self.export.groupByKeywords">
                            <div class="row">
                                <div class="form-group col-sm-4">
                                    <button ng-click="self.addGroupByKeywordTitleKeyword()"
                                            type="button"
                                            class="btn">
                                        <?= $this->translate('export_action_add_groupByKeywordTitle_keyword') ?>
                                    </button>
                                </div>
                            </div>

                            <div ng-repeat="keyword in self.export.groupByKeywordsTitles.keywords track by $index">
                                <div class="row">
                                    <div class="form-group col-sm-4">

                                        <label for="groupByKeywordsTitles_keywords_{{ $index }}">
                                            <?= $this->translate('export_field_groupByKeywordsTitles_keywords') ?>
                                            de niveau {{ $index + 1 }}
                                        </label>

                                        <input ng-model="self.export.groupByKeywordsTitles.keywords[$index]"
                                               type="text"
                                               id="groupByKeywordsTitles_keywords_{{ $index }}"
                                               class="form-control">
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="form-group col-sm-4">
                                    <label for="groupByKeywordsTitles_parentProjects">
                                        <?= $this->translate('export_field_groupByKeywordsTitles_parentProjects') ?>
                                    </label>

                                    <input ng-model="self.export.groupByKeywordsTitles.parentProjects"
                                           type="text"
                                           id="groupByKeywordsTitles_parentProjects"
                                           class="form-control">

                                    <field-errors field="groupByKeywordsTitles"
                                                  errors="self.errors.fields">
                                    </field-errors>
                                </div>
                            </div>
                        </div>

                        <div ng-if="!self.export.groupByKeywords">
                            <div class="row">
                                <div class="form-group col-sm-4">
                                    <label for="showArbo">
                                        <?= $this->translate('export_field_showArbo') ?>
                                    </label>

                                    <select ng-model="self.export.showArbo"
                                            ng-readonly="!self.export._rights.update"
                                            id="showArbo"
                                            class="form-control">
                                        <?php foreach (\Export\Entity\Export::getShowArboChoices() as $choice): ?>
                                            <option value="<?= $choice ?>">
                                                <?= $this->translate('export_showArbo_' . $choice) ?>
                                            </option>
                                        <?php endforeach ?>
                                    </select>

                                    <field-errors field="showArbo"
                                                  errors="self.errors.fields">
                                    </field-errors>
                                </div>
                            </div>

                            <div ng-if="self.export.showArbo === '<?= \Export\Entity\Export::SHOW_ARBO_COLUMNS ?>'"
                                 class="row">
                                <div class="form-group col-sm-4">
                                    <label for="dataArbo">
                                        <?= $this->translate('export_field_dataArbo') ?>
                                    </label>

                                    <select ng-model="self.export.dataArbo"
                                            ng-readonly="!self.export._rights.update"
                                            required
                                            id="dataArbo"
                                            class="form-control">
                                        <?php foreach (\Export\Entity\Export::getDataArboChoices() as $choice): ?>
                                            <option value="<?= $choice ?>">
                                                <?= $this->translate('export_dataArbo_' . $choice) ?>
                                            </option>
                                        <?php endforeach ?>
                                    </select>

                                    <field-errors field="dataArbo"
                                                  errors="self.errors.fields">
                                    </field-errors>
                                </div>
                            </div>
                        </div>

                        <div class="row separator">
                            <div class="col-xs-12">
                                <div class="row">
                                    <div class="col-sm-3">
                                        <div class="panel-group" id="accordion">
                                            <div class="input-group separator">
                                                <input type="search" ng-model="search" class="form-control"/>
                                                <div class="input-group-addon">
                                                    <?= $this->icon('search') ?>
                                                </div>
                                            </div>
                                            <?php
                                            $modals = '';
                                            $i      = 0;
                                            foreach ($this->fields as $categoryName => $category) {
                                                $options = $category['options'];

                                                $ngIf = null;
                                                if (isset($options['onlyProject']) && $options['onlyProject'] === true) {
                                                    $ngIf = 'self.export.reference === \'initial\' || self.currentTemplate.type == \'parent_project\' || self.currentTemplate.type == \'node_project\' || self.currentTemplate.type == \'leaf_project\'';
                                                } else if (isset($options['onlyKeyword']) && $options['onlyKeyword'] === true) {
                                                    $ngIf = 'self.export.reference !== \'initial\' && self.currentTemplate.type !== \'parent_project\' && self.currentTemplate.type !== \'node_project\' && self.currentTemplate.type !== \'leaf_project\'';
                                                }

                                                echo '<div class="panel panel-default"  filter-list="search" '.($ngIf ? ' ng-if="'.$ngIf.'"' : '').'>';
                                                    echo '<div class="panel-heading pointer" data-toggle="collapse" data-parent="#accordion" href="#' . $categoryName . '">';
                                                        echo '<a>';
                                                            echo $this->icon($options['icon'], 'fa-fw') . ' ';
                                                            echo $options['title'];
                                                        echo '</a>';
                                                    if ($categoryName == 'pictures') {
                                                        echo '<div class="pull-right">';
                                                            echo '<a class="pointer" ng-click="self.configureVariable(\'addPictureGlobal\')"><span class="glyphicon glyphicon-plus"></span></a>';
                                                        echo '</div>';
                                                    }
                                                    echo '</div>';
                                                    echo '<div id="' . $categoryName . '" class="panel-collapse collapse">';
                                                        echo '<div class="panel-body panel-variable">';

                                                            foreach ($category as $type => $fields) {
                                                                if ($type !== 'options' && $fields) {
                                                                    switch ($type) {
                                                                        case 'data':
                                                                            $title = null;
                                                                            break;
                                                                        default:
                                                                            $title = '<i class="fa fa-tag fa-fw"></i> ' . $type;
                                                                    }

                                                                    echo '<div class="col-sm-12">';
                                                                        if (isset($title)) {
                                                                            echo '<b class="variables-category">' . $title . ' :</b>';
                                                                        }
                                                                        echo '<ul class="list-unstyled separator">';
                                                                        foreach ($fields as $key => $field) {
                                                                            $text = $field['text'];
                                                                            $ngClick = 'self.configureVariable(\'' . $key . '\', \'' . str_replace('"', '&quot;', str_replace("'", "\'", $text)) . '\')';

                                                                            echo '<li>';
                                                                                echo '<label class="variable no-bold pointer" ng-click="' . $ngClick . '" title="$' . $key . '$">';
                                                                                     echo $text;
                                                                                echo '</label>';
                                                                                if (isset($field['help'])) {
                                                                                    echo '<small class="help-block">';
                                                                                        echo $field['help'];
                                                                                    echo '</small>';
                                                                                }

                                                                                if (isset($field['params'])) {
                                                                                    $i++;
                                                                                    $modals .= '<div id="params_' . preg_replace(['/(\()(.*)(\))/', '/,/'], ['_$2', '_'], $key) . '" class="modal fade">';
                                                                                        $modals .= '<div class="modal-dialog">';
                                                                                            $modals .= '<div class="modal-content">';
                                                                                                $modals .= '<form name="form' . $i . '" ng-submit="self.insertConfiguredVariable()">';
                                                                                                    $modals .= '<div class="modal-header">';
                                                                                                        $modals .= 'Paramètres de la variable : <b>' . $text . '</b>';
                                                                                                    $modals .= '</div>';
                                                                                                    $modals .= '<div class="modal-body">';
                                                                                                        foreach ($field['params'] as $paramName => $param) {
                                                                                                            $required = isset($param['required']) ? $param['required'] : true;
                                                                                                            $if       = isset($param['if'])       ? 'ng-if="' . $param['if'] . '"' : '';
                                                                                                            $modals .= '<div class="row" '. $if .'>';
                                                                                                                $modals .= '<div class="form-group col-xs-12 ' . ($required ? 'required' : '') . '">';
                                                                                                                    $modals .= '<label>' . $param['text'] . ' : </label>';
                                                                                                                    switch ($param['type']) {
                                                                                                                        case 'hidden':
                                                                                                                            $modals .= '<input type="hidden" ng-model="self.variablesParams.'.$paramName.'" ' . ($required ? 'required' : '') . ' />';
                                                                                                                            break;
                                                                                                                        case 'boolean':
                                                                                                                            $modals .= '<select name="' . $paramName . '" class="form-control" ng-model="self.variablesParams.'.$paramName.'" ' . ($required ? 'required' : '') . '>';
                                                                                                                                $modals .= '<option value=""></option>';
                                                                                                                                $modals .= '<option value="true">Oui</option>';
                                                                                                                                $modals .= '<option value="false">Non</option>';
                                                                                                                            $modals .= '</select>';
                                                                                                                            break;
                                                                                                                        case 'multiple':
                                                                                                                            $modals .= '<select name="' . $paramName . '" class="form-control" multiple ng-model="self.variablesParams.'.$paramName.'" ' . ($required ? 'required' : '') . '>';
                                                                                                                                $modals .= $required ? '' : '<option value=""></option>';
                                                                                                                                foreach ($param['options'] as $optionValue => $optionName) {
                                                                                                                                    $modals .= '<option value="' . $optionValue . '">' . $optionName . '</option>';
                                                                                                                                }
                                                                                                                            $modals .= '</select>';
                                                                                                                            break;
                                                                                                                        case 'unique':
                                                                                                                            $modals .= '<select name="' . $paramName . '" class="form-control" ng-model="self.variablesParams.'.$paramName.'" ' . ($required ? 'required' : '') . '>';
                                                                                                                                $modals .= '<option value=""></option>';
                                                                                                                                foreach ($param['options'] as $optionValue => $optionName) {
                                                                                                                                    $modals .= '<option value="' . $optionValue . '">' . $optionName . '</option>';
                                                                                                                                }
                                                                                                                            $modals .= '</select>';
                                                                                                                            break;
                                                                                                                    }
                                                                                                                $modals .= '</div>';
                                                                                                            $modals .= '</div>';
                                                                                                        }
                                                                                                    $modals .= '</div>';
                                                                                                    $modals .= '<div class="modal-footer">';
                                                                                                        $modals .= '<button class="btn btn-default" type="button" data-dismiss="modal">' . $this->translate('close') . '</button>';
                                                                                                        $modals .= '<button type="submit" class="btn btn-submit" type="button">' . $this->translate('insert') . '</button>';
                                                                                                    $modals .= '</div>';
                                                                                                $modals .= '</form>';
                                                                                            $modals .= '</div>';
                                                                                        $modals .= '</div>';
                                                                                    $modals .= '</div>';
                                                                                }
                                                                            echo '</li>';
                                                                        }
                                                                        echo '</ul>';
                                                                    echo '</div>';
                                                                }
                                                            }
                                                        echo '</div>';
                                                    echo '</div>';
                                                echo '</div>';
                                            }
                                            ?>
                                        </div>
                                    </div>
                                    <div class="col-sm-9">
                                        <div class="tab-content">
                                            <div class="tab-pane active">
                                                <table class="table table-bordered">
                                                    <thead>
                                                        <tr>
                                                            <th><?= ucfirst($this->translate('export_special_field_order')) ?></th>
                                                            <th><?= ucfirst($this->translate('export_special_field_field')) ?></th>
                                                            <th><?= ucfirst($this->translate('export_special_field_translation')) ?></th>
                                                            <th><?= ucfirst($this->translate('export_special_field_params')) ?></th>
                                                            <th class="actions-column"></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody ui-sortable ng-model="self.cols">
                                                        <tr ng-repeat="col in self.cols">
                                                            <td style="cursor: move">{{$index + 1}}</td>
                                                            <td>{{col.name}}</td>
                                                            <td><input class="form-control input-sm" ng-model="col.translation"></td>
                                                            <td>{{col.params}}</td>
                                                            <td>
                                                                <button class="btn btn-default btn-xs" type="button" ng-click="self.deleteCol($index)">
                                                                    <?= $this->icon('delete', 'fa-fw') ?>
                                                                </button>
                                                            </td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div ng-if="self.export._rights.update" class="row">
                            <div class="col-xs-12">
                                <button type="submit" class="btn btn-submit" ng-disabled="self.loading.remove || self.loading.save">
                                    <?= $this->icon('loading', '', ['ng-if' => 'self.loading.save']) ?>
                                    <?= $this->translate('form_button_save') ?>
                                </button>
                            </div>
                        </div>
                    </form>
                    <?= $modals ?>
                </div>
            </div>
        </div>
    </div>
</div>

<?php
$fabLinks = [];

if ($this->acl()->isAllowed('export:e:export:c')) {
    $fabLinks[] = [
        'href' => $this->url('export/form/word'),
        'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('exportWord_nav_form'),
    ];
    $fabLinks[] = [
        'href' => $this->url('export/form/excel'),
        'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('exportExcel_nav_form'),
    ];

    if ($this->acl()->isAllowed('directory:e:job:r')) {
        $fabLinks[] = [
            'href' => $this->url('export/form/publipostages'),
            'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('exportPublipostage_nav_form')
        ];
    }
}

echo $this->fabMenu($fabLinks);

$this->angular('js/src/export/service/export.js');
$this->angular('js/src/export/controller/export/form-excel.js');

$this->angular('js/src/attachment/controller/attachment.js');
$this->angular('js/src/attachment/service/attachment.js');


